	list	p=16f84a
	include <p16f84a.inc>

	__CONFIG   _CP_OFF & _WDT_OFF & _XT_OSC

SongPos	equ  0C
PatPage	equ  0D
Chn1Val	equ  0E
Chn2Val	equ  0F
Chn1Cnt	equ  10
Chn2Cnt	equ  11
Chn1Bit	equ  12
Chn2Bit	equ  13
ChnLoop	equ  14
ChnSped equ  15
loop	equ  16



	org 0x000

Chn1TabPat4
	goto	Init
	retlw	0x72
	retlw	0x88
	retlw	0xAB
	retlw	0x88
	retlw	0x72
	retlw	0x56
	retlw	0x81
	retlw	0x84
	retlw	0x87
	retlw	0x8A
	retlw	0x8E
	retlw	0x93
	retlw	0x98
	retlw	0x9D
	retlw	0xA2
	retlw	0xA7
	retlw	0xAC
	retlw	0xB1
	retlw	0xC0
	retlw	0xD7
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x00


Init
	clrf	PORTB
	bsf	STATUS,RP0		; select bank1
	movlw	h'FE'			; set PORTB bit0 to output mode
	movwf	TRISB
	bcf	STATUS,RP0		; select bank0

InitMusic
	clrf	SongPos
	clrf	PatPage
	incf	PatPage,f		; first page is at 0x100

PlayMusic
	movf	SongPos,w		;1;
	sublw	0x7E			;1;
	btfss	STATUS,Z		;1(2);
	goto	pm4			;2;

	clrf	SongPos			;1;
	incf	PatPage,w		;1;
	andlw	0x03			;1;
	movwf	PatPage			;1;

pm4
	movf	PatPage,w		;1;
	movwf	PCLATH			;1; select current pattern page

	movf	SongPos,w		;1;
	call	Chn1TabPat1		;2; get next Chn1 value
	movwf	Chn1Val			;1;
	
	movf	SongPos,w		;1;
	call	Chn2TabPat1		;2; get next Chn2 value
	movwf	Chn2Val			;1;

	incf	SongPos,f		;1; point to next note

	clrf	ChnLoop			;1;
	movlw	0x13			;1; set song speed
	movwf	ChnSped			;1;

	movlw	0x01			;1; subwf will modify C bit
	subwf	Chn1Val,w		;1;
	btfss	STATUS,C		;1(2); Chn1Val == 0?
	goto	InitMusic		;2; restart music
	btfss	STATUS,Z		;1(2); Chn1Val == 1?
	goto	pm1			;2; continue playing if Chn1Val > 1
	decf	Chn2Val,w		;1;
	btfsc	STATUS,Z		;1(2); continue playing if Chn1Val > 1
	goto	DummyWait		;2; wait silently if no sound

pm1
	clrf	Chn1Bit			;1;
	clrf	Chn2Bit			;1;
	movlw	0x01			;1;
	movwf	Chn1Cnt			;1;
	movwf	Chn2Cnt			;1;

pmloop1
	nop				;1;

pmloop2
	movf	Chn1Bit,w		;1;
	movwf	PORTB			;1; write Channel #1 bit to output

	nop				;1;
	nop				;1;
	nop				;1;
	nop				;1;

	decfsz	Chn1Cnt,f		;1(2);
	goto	pm2			;2;

	xorlw	0x01			;1; invert Channel #1 bit (already in w)
	movwf	Chn1Bit			;1;
	movf	Chn1Val,w		;1; restore Channel #1 counter
	movwf	Chn1Cnt			;1;
	goto	pm2a			;2;

pm2
	nop				;1;
	nop				;1;
	nop				;1;
	nop				;1;
	nop				;1;

pm2a
	movf	Chn2Bit,w		;1;
	movwf	PORTB			;1; write Channel #2 bit to output

	decfsz	Chn2Cnt,f		;1(2);
	goto	pm3			;2;

	xorlw	0x01			;1; invert Channel #2 bit (already in w)
	movwf	Chn2Bit			;1;
	movf	Chn2Val,w		;1; restore Channel #2 counter
	movwf	Chn2Cnt			;1;
	goto	pm3a			;2;

pm3
	nop				;1;
	nop				;1;
	nop				;1;
	nop				;1;
	nop				;1;

pm3a
	decfsz	ChnLoop,f		;1(2);
	goto	pmloop1			;2;

	decfsz	ChnSped,f		;1(2);
	goto	pmloop2			;2;

	goto	PlayMusic		;2;

; waits ChnSped * 7ms
DummyWait
	movlw	7			;1;
	movwf	loop			;1;
	nop				;1;
	nop				;1;
dw1
	decfsz	loop,f			;1(2);
	goto	dw1			;2;
	decfsz	ChnLoop,f		;1(2);
	goto	DummyWait		;2;
	decfsz	ChnSped,f		;1(2);
	goto	DummyWait		;2;
	goto	PlayMusic		;2;


	org		0x080

Chn2TabPat4
	addwf	PCL,f
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0x80
	retlw	0xFF
	retlw	0xFF
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x01
	retlw	0x00


	org 0x100
Chn1TabPat1
	addwf	PCL,f
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xA1

Chn2TabPat1
	addwf	PCL,f
	retlw	0x40
	retlw	0x01
	retlw	0x36
	retlw	0x01
	retlw	0x2B
	retlw	0x01
	retlw	0x40
	retlw	0x01
	retlw	0x36
	retlw	0x01
	retlw	0x2B
	retlw	0x01
	retlw	0x48
	retlw	0x01
	retlw	0x39
	retlw	0x01
	retlw	0x30
	retlw	0x01
	retlw	0x24
	retlw	0x01
	retlw	0x30
	retlw	0x01
	retlw	0x39
	retlw	0x01
	retlw	0x28
	retlw	0x01
	retlw	0x24
	retlw	0x01
	retlw	0x28
	retlw	0x01
	retlw	0x28
	retlw	0x01
	retlw	0x24
	retlw	0x01
	retlw	0x28
	retlw	0x01
	retlw	0x44
	retlw	0x44
	retlw	0x40
	retlw	0x40
	retlw	0x39
	retlw	0x01
	retlw	0x39
	retlw	0x39
	retlw	0x40
	retlw	0x2B
	retlw	0x44
	retlw	0x2B
	retlw	0x80
	retlw	0x01
	retlw	0x40
	retlw	0x39
	retlw	0x36
	retlw	0x30
	retlw	0x36
	retlw	0x01
	retlw	0x39
	retlw	0x01
	retlw	0x40
	retlw	0x01
	retlw	0x39
	retlw	0x39
	retlw	0x40
	retlw	0x40
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x51
	retlw	0x48
	retlw	0x40
	retlw	0x39
	retlw	0x40
	retlw	0x01
	retlw	0x48
	retlw	0x01
	retlw	0x51
	retlw	0x01
	retlw	0x39
	retlw	0x39
	retlw	0x36
	retlw	0x36
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x36
	retlw	0x36
	retlw	0x39
	retlw	0x39
	retlw	0x01
	retlw	0x01
	retlw	0x40
	retlw	0x39
	retlw	0x36
	retlw	0x30
	retlw	0x36
	retlw	0x01
	retlw	0x39
	retlw	0x01
	retlw	0x40
	retlw	0x01
	retlw	0x39
	retlw	0x01
	retlw	0x36
	retlw	0x01
	retlw	0x30
	retlw	0x01
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0xA1
	retlw	0x01
	retlw	0x40
	retlw	0x39
	retlw	0x36
	retlw	0x30
	retlw	0x36

	org 0x200
Chn1TabPat2
	addwf	PCL,f
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x60
	retlw	0x72
	retlw	0x60
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0xAB
	retlw	0x72
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x90
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x90
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0xA1
	retlw	0x6C
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0xA1
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0xAB
	retlw	0x72
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x72
	retlw	0x72
	retlw	0x88
	retlw	0x72
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90

Chn2TabPat2
	addwf	PCL,f
	retlw	0x36
	retlw	0x36
	retlw	0x39
	retlw	0x39
	retlw	0x40
	retlw	0x40
	retlw	0x39
	retlw	0x39
	retlw	0x36
	retlw	0x36
	retlw	0x30
	retlw	0x30
	retlw	0x2B
	retlw	0x2B
	retlw	0x22
	retlw	0x22
	retlw	0x2B
	retlw	0x2B
	retlw	0x20
	retlw	0x2B
	retlw	0x36
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x20
	retlw	0x2B
	retlw	0x36
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x24
	retlw	0x30
	retlw	0x39
	retlw	0x30
	retlw	0x39
	retlw	0x30
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x48
	retlw	0x39
	retlw	0x39
	retlw	0x36
	retlw	0x36
	retlw	0x30
	retlw	0x01
	retlw	0x30
	retlw	0x30
	retlw	0x36
	retlw	0x36
	retlw	0x39
	retlw	0x39
	retlw	0x44
	retlw	0x44
	retlw	0x40
	retlw	0x40
	retlw	0x39
	retlw	0x39
	retlw	0x36
	retlw	0x36
	retlw	0x39
	retlw	0x39
	retlw	0x44
	retlw	0x44
	retlw	0x20
	retlw	0x2B
	retlw	0x36
	retlw	0x2B
	retlw	0x20
	retlw	0x1B
	retlw	0x18
	retlw	0x1B
	retlw	0x1C
	retlw	0x1B
	retlw	0x1C
	retlw	0x20
	retlw	0x1C
	retlw	0x20
	retlw	0x24
	retlw	0x1C
	retlw	0x20
	retlw	0x26
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x20
	retlw	0x24
	retlw	0x28
	retlw	0x36
	retlw	0x24
	retlw	0x28
	retlw	0x20
	retlw	0x24
	retlw	0x28
	retlw	0x36
	retlw	0x24
	retlw	0x28
	retlw	0x22
	retlw	0x22
	retlw	0x20
	retlw	0x20
	retlw	0x1C
	retlw	0x1C
	retlw	0x1B
	retlw	0x1B
	retlw	0x1C
	retlw	0x1C
	retlw	0x22
	retlw	0x22
	retlw	0x20
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x20
	retlw	0x2B
	retlw	0x20
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x20
	retlw	0x2B
	retlw	0x24

	org 0x300
Chn1TabPat3
	addwf	PCL,f
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x90
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0xA1
	retlw	0x6C
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xFF
	retlw	0x01
	retlw	0xD7
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0xFF
	retlw	0x01
	retlw	0xD7
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x60
	retlw	0x01
	retlw	0xA1
	retlw	0x20
	retlw	0x80
	retlw	0x20
	retlw	0x6C
	retlw	0x20
	retlw	0xA1
	retlw	0x20
	retlw	0x80
	retlw	0x20
	retlw	0x6C
	retlw	0x20
	retlw	0xAB
	retlw	0x56
	retlw	0x88
	retlw	0x56
	retlw	0x72
	retlw	0x56
	retlw	0xAB
	retlw	0x56
	retlw	0x88
	retlw	0x56
	retlw	0x72
	retlw	0x56
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x80
	retlw	0x01
	retlw	0x6C
	retlw	0x01
	retlw	0x56
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x90
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0x72
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0xA1
	retlw	0x80
	retlw	0x01
	retlw	0xA1
	retlw	0x01
	retlw	0x80
	retlw	0xA1
	retlw	0x80
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x88
	retlw	0x01
	retlw	0xAB
	retlw	0x01
	retlw	0x00

Chn2TabPat3
	addwf	PCL,f
	retlw	0x24
	retlw	0x30
	retlw	0x39
	retlw	0x30
	retlw	0x24
	retlw	0x20
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x24
	retlw	0x39
	retlw	0x39
	retlw	0x36
	retlw	0x36
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x30
	retlw	0x36
	retlw	0x36
	retlw	0x39
	retlw	0x39
	retlw	0x2B
	retlw	0x39
	retlw	0x26
	retlw	0x39
	retlw	0x22
	retlw	0x39
	retlw	0x22
	retlw	0x39
	retlw	0x20
	retlw	0x39
	retlw	0x1C
	retlw	0x39
	retlw	0x20
	retlw	0x20
	retlw	0x1C
	retlw	0x1C
	retlw	0x1B
	retlw	0x1B
	retlw	0x1B
	retlw	0x1B
	retlw	0x1C
	retlw	0x1C
	retlw	0x20
	retlw	0x20
	retlw	0x1C
	retlw	0x24
	retlw	0x30
	retlw	0x36
	retlw	0x39
	retlw	0x48
	retlw	0x60
	retlw	0x48
	retlw	0x39
	retlw	0x24
	retlw	0x1C
	retlw	0x18
	retlw	0x1B
	retlw	0x18
	retlw	0x15
	retlw	0x18
	retlw	0x1B
	retlw	0x18
	retlw	0x1B
	retlw	0x18
	retlw	0x15
	retlw	0x1B
	retlw	0x20
	retlw	0x2B
	retlw	0x1C
	retlw	0x2B
	retlw	0x1B
	retlw	0x2B
	retlw	0x18
	retlw	0x2B
	retlw	0x1B
	retlw	0x2B
	retlw	0x1C
	retlw	0x2B
	retlw	0x20
	retlw	0x1C
	retlw	0x20
	retlw	0x28
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x36
	retlw	0x20
	retlw	0x28
	retlw	0x2B
	retlw	0x36
	retlw	0x40
	retlw	0x36
	retlw	0x24
	retlw	0x30
	retlw	0x36
	retlw	0x39
	retlw	0x40
	retlw	0x39
	retlw	0x24
	retlw	0x30
	retlw	0x36
	retlw	0x39
	retlw	0x36
	retlw	0x24
	retlw	0x28
	retlw	0x20
	retlw	0x28
	retlw	0x30
	retlw	0x36
	retlw	0x40
	retlw	0x51
	retlw	0x36
	retlw	0x40
	retlw	0x36
	retlw	0x40
	retlw	0x28
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x2B
	retlw	0x00

	end
