
C4B3 LD HL,C585		; music #1
C4B6 CALL C4CA
C4B9 JR C4AC
C4BB LD HL,C58A		; music #2
C4BE JR C4B6
C4C0 LD HL,C58F		; music #3
C4C3 JR C4B6
C4C5 LD HL,C594		; music #4
C4C8 JR C4B6
C4CA LDIR
C4CC CALL C4EE		; play one note
C4CF CALL 028E		; KEY-SCAN
C4D2 INC E
C4D3 JR Z,C4CC
C4D5 RET		; key pressed -> exit music

--------------------------------------------

; internal data
C4D6 DB xxxx		; channel #1 pointer
C4D8 DB xxxx		; channel #2 pointer
C4DA DB xx		; song speed

; increment note pointer
C4DB LD E,(HL)
C4DC INC HL
C4DD LD D,(HL)
C4DE INC DE		; step to next note
C4DF LD A,(DE)
C4E0 CP 02		; end-of-song marker
C4E2 JR Z,C4EB		; exit if end-of-song
C4E4 LD (HL),D
C4E5 DEC HL
C4E6 LD (HL),E
C4E7 LD H,A		; H=note, L=1
C4E8 LD L,01
C4EA RET
C4EB POP HL
C4EC POP HL
C4ED RET		; music routine exit

C4EE LD HL,C4D6		; channel #1
C4F1 CALL C4DB		; increment pointer
C4F4 PUSH HL		; save note#1
C4F5 LD HL,C4D8		; channel #2
C4F8 CALL C4DB		; increment pointer
C4FB POP DE		; DE=note#1, HL=note#2
C4FC LD B,00		; B = count 256 times
C4FE LD A,(C4DA)	;
C501 LD C,A		; C = song speed

C507 LD A,L
C508 CP H		; H=L?  (note#2 == 1)
C509 JR NZ,C50E
C50B CP D		; D=L?  (note#1 == 1)
C50C JR Z,C542		; if both eq 1 then skip sound just waits

C50E XOR A		;04; clear channel #1 bit
C50F EX AF,AF'		;04;
C510 XOR A		;04; clear channel #2 bit
C511 LD IXh,D		;08; save note#1 into IX
C513 LD D,10		;07; set/reset bit 4 to on/off buzzer

; Always 48 cycles between two out = 13.7us @3.5MHz

C515 NOP		;04; wait a little, 2x4 T-Cycles (2.3us @3.5MHz)
C516 NOP		;04;
C517 EX AF,AF'		;04; switch to channel #1
C518 DEC E		;04;
C519 OUT (FE),A		;11; output channel #1
C51B JR NZ,C530		;12/07;
C51D LD E,IXh		;08; restore note#1 value
C51F XOR D		;04; invert bit 4 in channel #1 (but only when E=0 note#1 time)

C520 EX AF,AF'		;04; switch to channel #2
C512 DEC L		;04;
C522 JP NZ,C537		;10;
C525 OUT (FE),A		;11; output channel #2
C527 LD L,H		;04;
C528 XOR D		;04; invert bit 4 in channel #2 (but only when L=0 note#2 time)
C529 DJNZ C515		;08/13;
C52B INC C		;04; "song speed" counter
C52C JP NZ,C517		;10;
C52F RET		;10;

C530 JR Z,C530		;12/07; wait a little, 7 T-Cycles (2.0 us @3.5MHz)
C532 EX AF,AF'		;04; switch to channel #2
C533 DEC L		;04;
C534 JP Z,C525		;10;
C537 OUT (FE),A		;11; output channel #2
C539 NOP		;04; wait a little, 8 T-Cycles (2.3 us @3.5MHz)
C53A NOP		;04;
C53B DJNZ C515		;08/13;
C53D INC C		;04; "song speed" counter
C53E JP NZ,C517		;10;
C541 RET		;10;

; wait for "song speed" time
C542 PUSH BC		;11;
C543 LD B,04		;07;
C545 DJNZ C545		;08/13; internal loop 4 times
C547 POP BC		;10;
C548 DEC B		;04; B counts 256 times
C549 JP NZ,C542		;10;
C54C INC C		;04; the lower the C the higher the wait
C54D JR NZ,C542		;12/07;
C54F RET		;10;

; music #1
C585 DB 0xC5A7		; ch1		0000  (289 bytes)
     DB 0xC6C8		; ch2		0121  (289 bytes)
     DB 0xED		; speed

; music #2
C58A DB 0xC7E9		; ch1		0242  (401 bytes)
     DB 0xC97A		; ch2		03D3  (401 bytes)
     DB 0xED		; speed

; music #3
C58F DB 0xCB0B		; ch1		0564  (273 bytes)
     DB 0xCC1C		; ch2		0675  (274 bytes)
     DB 0xEF		; speed

; music #4
C594 DB 0xCD2E		; ch1		0787  (193 bytes)
     DB 0xCDEF		; ch2		0848  (194 bytes)
     DB 0xE6		; speed
